#include "rpi.h"

static void mainloop() {
  unsigned int counter = 1;
  for (;;) {
    uart_printf(CONSOLE, "PI[%u]> ", counter++);
    for (;;) {
      char c = uart_getc(CONSOLE);
      uart_putc(CONSOLE, c);
      if (c == '\r') {
        uart_putc(CONSOLE, '\n');
        break;
      } else if (c == 'q') {
        uart_puts(CONSOLE, "\r\n");
        return;
      }
    }
  }
}

int kmain() {
  // set up GPIO pins for both console and marklin uarts
  gpio_init();

  // not strictly necessary, since line 1 is configured during boot
  // but we'll configure the line anyway, so we know what state it is in
  uart_config_and_enable(CONSOLE);

  char hello[] = "Hello world, this is iotest (" __TIME__ ")\r\nPress 'q' to reboot\r\n";
  uart_puts(CONSOLE, hello);
  mainloop();

  // exit to boot loader
  return 0;
}
